IncludeScript("vssaxtonhale/abilities/abilities.nut");

::playerAbilities <- {}
abilities <- [OverhealAbility, KritzAbility, EscapeAbility, SpeedAbility, SuckerJumpAbility, InvisAbility]

function GrantAbilityToPlayer(player, abilityType)
{
    if (!IsMercAlive(player))
        return;
    if (abilityType == null)
        playerAbilities[player] <- null
    else
        playerAbilities[player] <- abilityType(player);
}

function GrantRandomAbilityToPlayer(player)
{
    EmitSoundOn("Halloween.spell_pickup", player);
    GrantAbilityToPlayer(player, abilities[RandomInt(0, abilities.len()-1)])
}

function TryGrantRandomAbilityToPlayer(player)
{
    if (GetCurrentAbility(player) != null || !IsMercAlive(player) || IsNotValidRound())
        return false;
    GrantAbilityToPlayer(player, OpeningAbility);
    return true;
}

function GetCurrentAbility(player)
{
    return player in playerAbilities ? playerAbilities[player] : null;
}