class DemoShieldProtectionChange extends MercChange
{
    wasDestroyed = false;
    function CanApply()
    {
        if (player.GetPlayerClass() != TF_CLASS.DEMO)
            return false;
        //todo not exactly a fast method, but will do for now
        local wearable = null;
        while (wearable = Entities.FindByClassname(wearable, "tf_wearable_demo*"))
            if (wearable.GetOwner() == player)
                return true;
        return false;
    }

    function OnDamageTaken(params)
    {
        if (wasDestroyed)
            return;
        wasDestroyed = true;

        params.damage = 0;

        local wearable = null;
        while (wearable = Entities.FindByClassname(wearable, "tf_wearable_demo*"))
            if (wearable.GetOwner() == player)
                wearable.Kill();

        local deltaVector = player.GetCenter() - params.attacker.GetCenter();
        if (deltaVector.z < 60)
            deltaVector.z = 60;
        deltaVector.Norm();
        player.Yeet(deltaVector*900);

        EmitSoundOn("Player.Spy_Shield_Break", player);
        EmitSoundOn("Player.Spy_Shield_Break", player);
    }
}
mercChangesClasses.push(DemoShieldProtectionChange);