class MercChange
{
    lastFireTime = 0;
    lastWeapon = null;
    player = null;

    function constructor(player)
    {
        if (!IsValidPlayer(player))
            return;
        this.player = player;
        if (!CanApply())
            return;
        if (!(player in mercChanges))
            mercChanges[player] <- [];
        mercChanges[player].push(this);
        OnApply();
    }
    function CanApply() { return true; }
    function OnApply() { }
    /*function Remove() { }
    function RemoveInner()
    {
        if (player in mercChanges)
        {
            local myIndex = mercChanges[player].find(this);
            if (myIndex != null)
                mercChanges[player].remove(myIndex);
        }
        Remove();
    }*/
    function OnTickInner()
    {
        /*if (!IsValidPlayer(player))
        {
            Remove();
            return;
        }*/
        TickWeaponInner();
        OnTick();
    }
    function OnTick() { }
    function TickWeaponInner()
    {
        local weapon = player.GetActiveWeapon();
        if (weapon != lastWeapon)
        {
            lastFireTime = 0;
            lastWeapon = weapon;
        }
        if (weapon != null)
        {
            local buttons = NetProps.GetPropInt(player, "m_nButtons");
            local lastFireTimeNew = NetProps.GetPropFloat(weapon, "LocalActiveWeaponData.m_flNextPrimaryAttack");
            if (lastFireTimeNew > lastFireTime && lastFireTime > 0)
                OnWeaponFired();
            lastFireTime = lastFireTimeNew;
        }
    }
    function OnWeaponFired() { }
    function OnDamageDealt(params) { }
    function OnDamageTaken(params) { }
}