//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

::currentHale <- null

::GetHale <- function()
{
    return currentHale;
}

function SetHale(newCurrentHale)
{
    currentHale = newCurrentHale;
}

function SetNextHale(newNextHale)
{
    local gamerules = Entities.FindByClassname(null, "tf_gamerules");
    gamerules.ValidateScriptScope();
    gamerules.GetScriptScope().nextHale <- newNextHale;
}

function SetNextHaleByIndex(newNextHaleIndex)
{
    SetNextHale(EntIndexToHScript(newNextHaleIndex));
}

::SetNextHale <- SetNextHale;
::SetNextHaleByIndex <- SetNextHaleByIndex;

::IsHale <- function(player)
{
    return player == GetHale() && IsValidPlayer(player);
}

::IsNotHale <- function(player)
{
    return player != GetHale() || IsNotValidPlayer(player);
}