class LastMannStandingChange extends MercChange
{
    function OnTick()
    {
        local mercsAlive = vsh_vscript.GetAliveMercCount(); //todo cache the value when the tick begins
        if (mercsAlive <= 3
             && !player.InCond(Constants.ETFCond.TF_COND_STEALTHED)
             && !player.InCond(Constants.ETFCond.TF_COND_FEIGN_DEATH))
            player.AddCondEx(Constants.ETFCond.TF_COND_OFFENSEBUFF, 0.2, player);
        if (mercsAlive == 1)    //No, it's not "else if", because engie + sentry combo benefits from both crits and minicrits
            player.AddCondEx(Constants.ETFCond.TF_COND_CRITBOOSTED_ON_KILL, 0.2, player);
    }
}
mercChangesClasses.push(LastMannStandingChange);