class WallClimbChange extends MercChange
{
    function OnWeaponFired()
    {
        if (GTFW_ReturnWeaponBySlotBool(player.GetActiveWeapon(), TF_WEAPONSLOTS.MELEE))
            RunWithDelay("TryClimb(activator)", player, 0.15);
    }
}
mercChangesClasses.push(WallClimbChange);

function TryClimb(player)
{
    local target = player.EyePosition() + (player.EyeAngles().Forward() * 100);

    local table = {
        start = player.EyePosition(),
        end = target,
        mask = Constants.FContents.CONTENTS_SOLID
             | Constants.FContents.CONTENTS_MOVEABLE
             | Constants.FContents.CONTENTS_WINDOW
             | Constants.FContents.CONTENTS_GRATE
    };
    local trace = TraceLineEx(table);

    if ("hit" in table && table.hit && "plane_normal" in table && table.plane_normal.z < 0.5)
    {
        player.ApplyAbsVelocityImpulse(Vector(0,0,600));
        RunWithDelay("activator.ApplyAbsVelocityImpulse(activator.EyeAngles().Forward() * 200)", player, 0.15);
    }
}