class GenericOnKillToOnHitChange extends MercChange
{
	static onKillToOnHitWeapons = [
		132
	];

	function CanApply()
    {
		return true;
	}

	function OnDamageDealt(params)
    {
		if (onKillToOnHitWeapons.find(GetItemID(params.weapon)) != null)
			AddHead(true);
	}

	function AddHead(eyelander)
    {
		NetProps.SetPropInt(player, "m_Shared.m_iDecapitations", NetProps.GetPropInt(player, "m_Shared.m_iDecapitations") + 1);
		if (eyelander)
		{
			if (player.GetPlayerClass() == TF_CLASS.DEMO && !player.InCond(Constants.ETFCond.TF_COND_DEMO_BUFF))
				player.AddCond(Constants.ETFCond.TF_COND_DEMO_BUFF);
			if (player.GetHealth() <= 300)
				player.SetHealth(player.GetHealth() + 15);
			player.AddCondEx(Constants.ETFCond.TF_COND_SPEED_BOOST, 0.01, 0.01);
		}
	}
}
mercChangesClasses.push(GenericOnKillToOnHitChange);