//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

function TickMercs(void)
{
    if (IsRoundSetup())
        foreach (player in GetAllValidMercs())
            TickMercDuringSetup(player);
}
AddListener("tick_only_valid", TickMercs, 0);

function TickMercDuringSetup(player)
{
    if (!IsPlayerAlive(player))
        player.ForceRegenerateAndRespawn();
    else
    {
        local desiredClass = NetProps.GetPropInt(player, "m_Shared.m_iDesiredPlayerClass");
        if (desiredClass != player.GetPlayerClass())
        {
            player.SetPlayerClass(desiredClass)
            player.ForceRegenerateAndRespawn();
        }
    }
}