//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

IncludeScript("vssaxtonhale/sound/sound.nut");

SOUND_VO_SAXTON_DIR <- "/vo/saxton_hale_megapieman/";

SOUND_VO_SAXTON_JUMP <- Sound(SOUND_VO_SAXTON_DIR, "saxton_jump", 9);

function PlayAnnouncerVO(sound, index = 0)
{
    EmitSoundEx({
        sound_name = sound.GetSound(index),
        channel = 7, //CHAN_VOICE2
        volume = 1.0,
        sound_level = 150,
        flags = 0,
        pitch = 100,
    });
}

function PlayVOAtEntity(entity, sound, index = 0)
{
    local sound = sound.GetSound(index);
    for(local i = 0; i < 2; i++)
        EmitSoundEx({
            sound_name = sound,
            channel = 7, //CHAN_VOICE2
            volume = 1.0,
            sound_level = 150,
            flags = 0,
            pitch = 100,
            origin = entity == null ? null : entity.GetCenter(),
            entity = entity,
            speaker_entity = entity
        });
}