//=========================================================================
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

::DEGREES_TO_RADIANS <- 3.14159 / 180.0;

enum HALE_JUMP_STATUS
{
    WALKING = 0,
    JUMP_STARTED = 1,
    CAN_DOUBLE_JUMP = 2,
    DOUBLE_JUMPED = 3
};

enum TF_CLASS
{
    UNDEFINED = 0,
    SCOUT = 1,
    SNIPER = 2,
    SOLDIER = 3,
    DEMO = 4,
    DEMOMAN = 4,
    MEDIC = 5,
    HEAVY = 6,
    PYRO = 7,
    SPY = 8,
    ENGINEER = 9,
    CIVILIAN = 10
};

TF_CLASS_NAMES <- [
    "Undefined",
    "Scout",
    "Sniper",
    "Soldier",
    "Demo",
    "Medic",
    "Heavy",
    "Pyro",
    "Spy",
    "Engineer",
    "Civilian"
];

enum TF_TEAM
{
    IGNORED = 1,
    RED = 2,
    MERC = 2,
    MERCS = 2,
    HALE = 3,
    BLU = 3,
    BLUE = 3,
};

enum TF_DEATHFLAG
{
    KILLER_DOMINATION = 1,
    ASSISTER_DOMINATION = 2,
    KILLER_REVENGE = 4
    ASSISTER_REVENGE = 8
    FIRST_BLOOD = 16
    DEAD_RINGER = 32
    INTERRUPTED = 64
    GIBBED = 128
    PURGATORY = 256
}

enum TF_SPELLS
{
    ROLLING = -2,
    EMPTY = -1,
    FIREBALL = 0,
    BATS = 1,
    OVERHEAL = 2,
    PUMPKINS = 3,
    PUMPKIN_MIRV = 3,
    BLAST_JUMP = 4,
    STEALTH = 5,
    SHADOW_LEAP = 6,
    BALL_O_LIGHTNING = 7,
    MINIFY = 8,
    TINY_MANN = 8,
    METOR_SHOWER = 9,
    MONOCULUS = 10,
    SUMMON_MONOCULUS = 10,
    SKELETONS = 11,
    SKELETON_HORDE = 11,
    BOXING_ROCKET_CAR = 12,
    BASE_JUMP_CAR = 13,
    OVERHEAL_CAR = 14,
    BOMB_HEAD_CAR  = 15
};

enum LIFE_STATE
{
    ALIVE = 0,
    DYING = 1,
    DEAD = 2,
    RESPAWNABLE = 3,
    DISCARDBODY = 4
}