//=========================================================================
//VSH 23w11b.
//
//Copyright LizardOfOz.
//This is a VERY early version intended to prototype maps.
//Expect things to change over time.
//
//Check the following links for updates:
//   https://tf2maps.net/members/lizardofoz.39426/#resources
//   https://twitter.com/LizardOfOz_
//   https://youtube.com/LizardOfOz
//
//Credits:
//  LizardOfOz - the original VSH Plugin. VSH Vscript recreation.
//  Maxxy, Velly, JPRAS - Saxton Hale's model imitating the Jungle Inferno short.
//  MegapiemanPHD - Hale's voice lines.
//  Yakibomb - give_tf_weapon script bundle (used for Hale's first-person hands model).
//=========================================================================

ClearGameEventCallbacks();

::vsh_vscript <- this;
::vsh_vscript_name <- self.GetName();
::vsh_vscript_entity <- self;

IncludeScript("vssaxtonhale/abilities/ability_manager.nut");
IncludeScript("vssaxtonhale/util/compatibility.nut");
IncludeScript("vssaxtonhale/util/constants.nut");
IncludeScript("vssaxtonhale/util/player_util.nut");
IncludeScript("vssaxtonhale/util/util.nut");
IncludeScript("vssaxtonhale/util/config.nut");
IncludeScript("vssaxtonhale/util/listeners.nut");
IncludeScript("vssaxtonhale/util/resources.nut");
IncludeScript("vssaxtonhale/gamemode/scoreboard.nut");
IncludeScript("vssaxtonhale/sound/sound_manager.nut");
IncludeScript("vssaxtonhale/give_tf_weapon/give_tf_weapon.nut");
IncludeScript("vssaxtonhale/give_tf_weapon/giveweapon_old.nut");
IncludeScript("vssaxtonhale/mercs/merc_changes/merc_changes.nut");
IncludeScript("vssaxtonhale/mercs/merc_converter.nut");
IncludeScript("vssaxtonhale/mercs/merc_events.nut");
IncludeScript("vssaxtonhale/mercs/merc_ticker.nut");
IncludeScript("vssaxtonhale/gamemode/round_logic.nut");
IncludeScript("vssaxtonhale/hale/hale_abilities.nut");
IncludeScript("vssaxtonhale/hale/hale_vars.nut");
IncludeScript("vssaxtonhale/hale/hale_converter.nut");
IncludeScript("vssaxtonhale/hale/hale_ticker.nut");
IncludeScript("vssaxtonhale/hale/hale_events.nut");
IncludeScript("vssaxtonhale/gamemode/hud.nut");
IncludeScript("vssaxtonhale/gamemode/gamerules.nut");
IncludeScript("vssaxtonhale/corelib/game_events.nut");

function OnPostSpawn()
{
    RegisterCustomWeapon("Hale's Own Fists", "Fists", function (weapon, player) {
        //`AddAttribute` writes the arguments as `float`, while "kill eater" inteprets the incoming bytes as `int`
        weapon.AddAttribute("kill eater", casti2f(9001), -1); //"Hale's Own Fists"
        weapon.AddAttribute("merasmus hat level display ONLY", casti2f(9001), -1);
        IS_UNINTENDED(weapon, true)
        local wearable_handle = this.CreateCustomWeaponModel(false, weapon, SAXTON_ARMS_MODEL_PATH)
        PlayerLoadoutGlobal_BonemergedArms[player] <- wearable_handle
    }, null, SAXTON_ARMS_MODEL_PATH, null);
    StartNewRound();
}